import { ensureDir, readFile, readJson, writeFile, writeJson } from 'fs-extra'
import { join } from 'pathe'
import path from 'path'

const FUNCTIONS_INTERNAL_SRC = '.netlify/functions-internal'

export const generateFunctionWithFileConfig = async (funcName: string) => {
  try {
    await writeFunctionAndConfig(funcName, FUNCTIONS_INTERNAL_SRC)
  } catch (error) {
    console.log('Generating Function with file config failed', error)
  }
}

const writeFunctionAndConfig = async (
  funcName: string,
  functionsSrc: string,
) => {
  const source = await readFile(
    path.resolve(__dirname, '../templates/functions/helloWorld/hello.js'),
  )
  const jsonConfig = await readJson(
    path.resolve(__dirname, '../templates/functions/helloWorld/hello.json'),
  )

  await ensureDir(join(functionsSrc, funcName))
  await writeFile(join(functionsSrc, funcName, `${funcName}.js`), source)
  await writeJson(join(functionsSrc, funcName, `${funcName}.json`), jsonConfig)
}
